var _excluded = ["onSelect", "type", "searchAction", "searchParams"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { useState } from 'react';
import { Spin, CustomizeIcon, Select } from 'rlj-design';
import { useRequest } from 'ahooks';
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/index.less";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var prefixCls = "".concat(PREFIX_CLS, "-personSelect"); // 根据type值来确定筛选哪个员工状态的人员

var DEFAULT_PARAMS = {
  sureOffBoarding: {
    fieldId: 'employeeStatus',
    selections: ['probation', 'formal']
  },
  mobilize: {
    fieldId: 'employeeStatus',
    selections: ['formal', 'probation', 'quitting']
  }
};

var PersonSelect = function PersonSelect(_ref) {
  var onSelect = _ref.onSelect,
      type = _ref.type,
      searchAction = _ref.searchAction,
      searchParams = _ref.searchParams,
      restProps = _objectWithoutProperties(_ref, _excluded);

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      options = _useState2[0],
      setOptions = _useState2[1];

  var _useState3 = useState(null),
      _useState4 = _slicedToArray(_useState3, 2),
      searchValue = _useState4[0],
      setSearchValue = _useState4[1];

  var _useState5 = useState(false),
      _useState6 = _slicedToArray(_useState5, 2),
      isShowNoData = _useState6[0],
      setIsShowNoData = _useState6[1];

  var _useRequest = useRequest(searchAction, {
    manual: true,
    debounceWait: 500,
    loadingDelay: 300,
    onSuccess: function onSuccess(data) {
      var _ref2 = data || {},
          list = _ref2.list;

      var newOptions = list === null || list === void 0 ? void 0 : list.map(function (item) {
        return _objectSpread(_objectSpread({}, item), {}, {
          label: item.name,
          value: JSON.stringify(item),
          dept_chain: item.parent_dept_chain
        });
      });
      setIsShowNoData(!(newOptions !== null && newOptions !== void 0 && newOptions.length) && !!searchValue);
      setOptions(newOptions);
    }
  }),
      getEmployee = _useRequest.run,
      loading = _useRequest.loading;

  var debounceFetcher = function debounceFetcher(value) {
    setSearchValue(value);
    var params = searchParams || {
      fields: [{
        fieldId: 'name',
        value: value
      }, type ? DEFAULT_PARAMS[type] : {}]
    };
    getEmployee(params);
  };

  var selectChange = function selectChange(value, option) {
    // 这里选择了人员之后放在.then中清除searchValue的值，因为立即清除的话会导致输入框显示的值有问题
    new Promise(function (resolve) {
      onSelect && onSelect(value, option);
      resolve();
    }).then(function () {
      setSearchValue(null);
      setOptions([]);
    });
  };

  return /*#__PURE__*/_jsx(Select, _objectSpread(_objectSpread({
    showSearch: true,
    onBlur: function onBlur() {
      setSearchValue(null);
      setOptions([]);
    },
    filterOption: false,
    onSearch: debounceFetcher,
    notFoundContent: loading ? /*#__PURE__*/_jsx(Spin, {
      size: "small"
    }) : isShowNoData && /*#__PURE__*/_jsxs("div", {
      className: "".concat(prefixCls, "-notFoundTips"),
      children: [/*#__PURE__*/_jsx(CustomizeIcon, {
        style: {
          fontSize: 64
        },
        type: "icon-zanwuyuangong"
      }), /*#__PURE__*/_jsx("p", {
        children: "\u6682\u65E0\u8BE5\u5458\u5DE5"
      })]
    }) // suffixIcon={null}
    ,
    placeholder: "\u8BF7\u8F93\u5165\u5458\u5DE5",
    onSelect: selectChange
  }, restProps), {}, {
    children: options === null || options === void 0 ? void 0 : options.map(function (item) {
      return /*#__PURE__*/_jsxs(Select.Option, {
        className: "".concat(prefixCls, "-optionItem"),
        value: item.value,
        children: [/*#__PURE__*/_jsxs("p", {
          className: "".concat(prefixCls, "-userInfoClass"),
          children: [/*#__PURE__*/_jsx("span", {
            children: item.label
          }), /*#__PURE__*/_jsx("span", {
            children: item.job_number
          })]
        }), /*#__PURE__*/_jsx("p", {
          className: "".concat(prefixCls, "-deptInfoClass"),
          children: item.dept_chain || '-'
        })]
      }, item.empId);
    })
  }));
};

export default PersonSelect;